#include <bits/stdc++.h>

using namespace std;

#define ll long long

struct Edge {
    ll l, r;
    int count;
    ll ans;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<vector<ll> > arr(n);
    for (int i = 0; i < n; i++) {
        ll elem;
        cin >> elem;
        arr[i].push_back(elem);
    }
    for (int i = 0; i < n - 1; i++) {
        int id;
        cin >> id;
        id--;
        for (int j = 0; j < arr[id + 1].size(); j++) {
            arr[id].push_back(arr[id + 1][j]);
        }
        vector<ll> pref_max(arr[id].size());
        vector<ll> suf_max(arr[id].size());
        pref_max[0] = arr[id][0];
        suf_max[arr[id].size() - 1] = arr[id][arr[id].size() - 1];
        for (int j = 1; j < arr[id].size(); j++) {
            pref_max[j] = max(pref_max[j - 1], arr[id][j]);
        }
        for (int j = arr[id].size() - 2; j >= 0; j--) {
            suf_max[j] = max(suf_max[j + 1], arr[id][j]);
        }
        ll ans = 0;
        for (int j = 0; j < arr[id].size(); j++) {
            ans += min(pref_max[j], suf_max[j]) - arr[id][j];
        }
        cout << ans << '\n';
        arr.erase(arr.begin() + id + 1);
    }
}
