#include <bits/stdc++.h>

using namespace std;

#define ll long long

map<pair<int, string>, ll> dp;
int n, k;

void generate(string &s, int count, int elem) {
    if (s.size() == k) {
        dp[{0, s}] = 0;
        if (count == elem) {
            dp[{0, s}] = 1;
        }
        return;
    }
    s.push_back('0');
    generate(s, count, elem);
    s.pop_back();
    s.push_back('1');
    generate(s, count + 1, elem);
    s.pop_back();
}

void rec1(string &s1, string &s, int id, int count, int k1, int it2) {
    if (it2 == s.size()) {
        dp[{id, s}] += dp[{id - 1, s1}];
        return;
    }
    if (count == k1) {
        s1.push_back('0');
        rec1(s1, s, id, 0, k1 - 1, it2);
        s1.pop_back();
        s1.push_back('1');
        rec1(s1, s, id, 0, k1 - 1, it2);
        s1.pop_back();
    } else {
        s1.push_back(s[it2]);
        rec1(s1, s, id, count + 1, k1, it2+1);
    }
}

void rec(string &s, int count, int elem, int sz, int sz1, int id) {
    if (s.size() == sz) {
        dp[{id, s}] = 0;
        if (count == elem) {
            string s1;
            rec1(s1, s, id, 0, k - 1, 0);
        }
        return;
    }
    s.push_back('0');
    rec(s, count, elem, sz, sz1, id);
    s.pop_back();
    s.push_back('1');
    rec(s, count + 1, elem, sz, sz1, id);
    s.pop_back();
}

ll Ans(string &s, int sz) {
    if (s.size() == sz) {
        return dp[{n - 1, s}];
    }
    ll ans = 0;
    s.push_back('0');
    ans += Ans(s, sz);
    s.pop_back();
    s.push_back('1');
    ans += Ans(s, sz);
    s.pop_back();
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    string s;
    generate(s, 0, arr[0]);
    int sz = k;
    int sz1 = k;
    for (int i = 1; i < n; i++) {
        if (k - i > 0) {
            sz += k - i;
        }
        string s1;
        rec(s1, 0, arr[i], sz, sz1, i);
        sz1 = sz;
    }
    string s1;
    int sz2 = min(k - 1, n - 1);
    cout << Ans(s1, (k + (k - sz2)) * (sz2 + 1) / 2);
}
