#include <bits/stdc++.h>

using namespace std;

#define ll long long

struct Edge {
    int x, y, time, count;
    vector<vector<bool> > visited;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > arr(n, vector<int>(m));
    int ans = 0;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        arr[x][y] = 1;
    }
    queue<Edge> q;
    vector<vector<bool> > visted(n, vector<bool>(m));
    q.push({0, 0, 0, 0, visted});
    while (!q.empty()) {
        Edge e = q.front();
        if (e.count == k && e.x == 0 && e.y == 0 && e.visited[n - 1][m - 1] && e.time == 2 * n + 2 * m - 4) {
            ans++;
        }
        q.pop();
        int i = e.x, j = e.y;
        if (i + 1 < n && !e.visited[i + 1][j]) {
            e.visited[i + 1][j] = true;
            q.push({i + 1, j, e.time + 1, e.count + arr[i + 1][j], e.visited});
            e.visited[i + 1][j] = false;
        }
        if (j + 1 < m && !e.visited[i][j + 1]) {
            e.visited[i][j + 1] = true;
            q.push({i, j + 1, e.time + 1, e.count + arr[i][j + 1], e.visited});
            e.visited[i][j + 1] = false;
        }
        if (i - 1 >= 0 && !e.visited[i - 1][j]) {
            e.visited[i - 1][j] = true;
            q.push({i - 1, j, e.time + 1, e.count + arr[i - 1][j], e.visited});
            e.visited[i - 1][j] = false;
        }
        if (j - 1 >= 0 && !e.visited[i][j - 1]) {
            e.visited[i][j - 1] = true;
            q.push({i, j - 1, e.time + 1, e.count + arr[i][j - 1], e.visited});
            e.visited[i][j - 1] = false;
        }
    }
    cout << ans;
    return 0;
}
